#!/usr/bin/env python
#---------------------------------------------------------------
# Project         : Linux-Mandrake
# Module          : rpm-rebuilder
# File            : files-to-requires.py
# Version         : $Id: files-to-requires.py,v 1.1 2000/10/01 19:23:34 flepied Exp $
# Author          : Frederic Lepied
# Created On      : Sat Sep 30 14:17:11 2000
#---------------------------------------------------------------

import rpm
import re
import sys
import os

verbose=(len(sys.argv) > 1)
    
IMPLICIT_DEPS = (
    'bash',
    'binutils',
    'make',
    'gcc',
    'glibc',
    'bzip2',
    'tar',
    'rpm',
    'patch',
    'glibc-devel',
    'spec-helper',
    # basesystem is bellow
    'setup',
    'filesystem',
    'basesystem',
    'sed',
    'initscripts',
    'console-tools',
    'utempter',
    'ldconfig',
    'chkconfig',
    'ntsysv',
    'SysVinit',
    'bdflush',
    'crontabs',
    'dev',
    'e2fsprogs',
    'etcskel',
    'fileutils',
    'findutils',
    'getty_ps',
    'grep',
    'gzip',
    'hdparm',
    'info',
    'kernel',
    'less',
    'logrotate',
    'losetup',
    'man',
    'mingetty',
    'modutils',
    'mount',
    'net-tools',
    'passwd',
    'procmail',
    'procps',
    'psmisc',
    'mandrake-release',
    'rootfiles',
    'rpm',
    'sash',
    'ash',
    'setserial',
    'shadow-utils',
    'sh-utils',
    'stat',
    'sysklogd',
    'tar',
    'termcap',
    'textutils',
    'time',
    'tmpwatch',
    'util-linux',
    'vim',
    'vixie-cron',
    'which',
    'perl-base',
    'msec',
    'lilo',
    'grub',
    'mkbootdisk',
    'isapnptools'
    )
db=rpm.opendb()

build_requires=[]
pkg2files={}

for line in sys.stdin.readlines():
    file=line[:-1]
    if not os.path.isdir(file):
        for idx in db.findbyfile(file):
            pkg=db[idx][rpm.RPMTAG_NAME]
            if pkg not in IMPLICIT_DEPS:
                if pkg not in build_requires:
                    build_requires.append(pkg)
                    if verbose: pkg2files[pkg]=[file]
                else:
                    if verbose: pkg2files[pkg].append(file)
            
del db

for d in build_requires:
    print d

if verbose:
    for p in pkg2files.keys():
        sys.stderr.write("%s: %s\n" % (p, pkg2files[p]))

# files-to-requires.py ends here
